<?xml version="1.0"?>
<config xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="urn:magento:framework:ObjectManager/etc/config.xsd">
    <preference for="Elogic\Storelocator\Api\Data\StorelocatorInterface"
                type="Elogic\Storelocator\Model\Storelocator"/>

    <preference for="Elogic\Storelocator\Api\StorelocatorRepositoryInterface"
                type="Elogic\Storelocator\Model\StorelocatorRepository"/>

    <type name="Magento\Framework\View\Element\UiComponent\DataProvider\CollectionFactory">
        <arguments>
            <argument name="collections" xsi:type="array">
                <item name="elogic_storelocator_listing_data_source" xsi:type="string">Elogic\Storelocator\Model\ResourceModel\Storelocator\Grid\Collection</item>
            </argument>
        </arguments>
    </type>

    <type name="Elogic\Storelocator\Model\ResourceModel\Storelocator\Grid\Collection">
        <arguments>
            <argument name="mainTable" xsi:type="string">store_locator</argument>
            <argument name="eventPrefix" xsi:type="string">elogic_storelocator_grid_collection</argument>
            <argument name="eventObject" xsi:type="string">store_storelocator_grid_collection</argument>
            <argument name="resourceModel" xsi:type="string">Elogic\Storelocator\Model\ResourceModel\Storelocator</argument>
        </arguments>
    </type>

    <type name="Elogic\Storelocator\Model\ImageUploader">
        <arguments>
            <!-- Temporary file stored in pub/media/faq/tmp/images -->
            <argument name="baseTmpPath" xsi:type="string">storelocator/images/</argument>
            <argument name="basePath" xsi:type="string">storelocator/images/</argument>
            <argument name="allowedExtensions" xsi:type="array">
                <item name="jpg" xsi:type="string">jpg</item>
                <item name="jpeg" xsi:type="string">jpeg</item>
                <item name="gif" xsi:type="string">gif</item>
                <item name="png" xsi:type="string">png</item>
            </argument>
        </arguments>
    </type>

    <type name="Elogic\Storelocator\Controller\Adminhtml\Storelocator\Edit\Upload">
        <arguments>
            <argument name="imageUploader" xsi:type="object">Elogic\Storelocator\Model\ImageUpload</argument>
        </arguments>
    </type>

    <type name="Elogic\Storelocator\Console\ImportStore">
        <arguments>
            <!-- configure the command name via constructor $name argument -->
            <argument name="name" xsi:type="string">elogic:storelocator-import-CSV</argument>
        </arguments>
    </type>
    <type name="Magento\Framework\Console\CommandListInterface">
        <arguments>
            <argument name="commands" xsi:type="array">
                <item name="elogic_storelocator" xsi:type="object">Elogic\Storelocator\Console\ImportStore</item>
            </argument>
        </arguments>
    </type>

</config>
